/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@Fgcc -fopenmp -o Program_1 Source_Program_1.c
  
*/
#include <stdio.h>
#include <omp.h>
#define PATTERN (0x0ABCDEF00)	// 6  
#define COUNT   (10)
static struct {int a,b;} found[COUNT];
static unsigned int      count=COUNT;

static int mul11(int a, int c) { return (a * c) << 16; }
static int mul12(int a, int d) { return (a * d) << 8; }
static int mul21(int c, int b) { return (c * b) << 8; }
static int mul22(int b, int d) { return (b * d); }
static int addAB(int A, int B) { return (A + B); }
static int addCD(int C, int D) { return (C + D); }
static int addEF(int E, int F) { return (E + F); }
static int check(int X) { return !(X ^ PATTERN); }

void sub(unsigned int i)
{
  int a,b,c,d,A,B,C,D,E,F,X;
  unsigned int j;

  for ( j = 0 ; count && j <= 0xFFFF ; j++ )
  {
    a = i >> 8;		// 1oCgo(ӏ)
    b = i & 0xFF;	// 1oCgo(Ӊ)
    c = j >> 8;		// 1oCgo(Eӏ)
    d = j & 0xFF;	// 1oCgo(EӉ)
    D = mul22(b,d);	// ZP(ʁ~)
    B = mul12(a,d);	// ZQ(ʁ~) << 8
    C = mul21(c,b);	// ZR(ʁ~) << 8
    A = mul11(a,c);	// ZS(ʁ~) << 16
    F = addCD(C,D);	// ZP(ZP{ZR)
    E = addAB(A,B);	// ZQ(ZQ{ZS)
    X = addEF(E,F);	// ZR(ZP{ZQ)
    if( check(X) )
    {
#pragma omp critical(crit_val)
      {
	count--;
	found[count].a = i;
	found[count].b = j;
      }
      printf("%8.8X = %4.4X * %4.4X\n",X,i,j);
    }
  }
  return;
}
void main(void)
{
  unsigned int i;
  
#pragma omp parallel for
  for ( i = 0 ; i <= 0xFFFF ; i++ )
    sub(i);

  return;
}
